Unit sf40e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF23Z_p, UTSF13_p, SF39E_p;

function sf40e(X :Extended; P :Extended; var IERR :Integer): Extended;

implementation

function sf40e(X :Extended; P :Extended; var IERR :Integer): Extended;
var
IERR1 :Integer;
R1,R2,EPS :Extended;
const
PMAX :Real = 408.909e0;
SYS059 :Real = 1.7E308;
SYS089 :Real = 1.0e-15;
label
_1,_2,_3,_4;
begin
{ Result -    SF40E  FORTRANe }
if ( X >= 0.e0 ) 
 then goto _1;
IERR := 65;
Result := SYS059;
goto _4;
_1:
if ( P > 0.e0 ) 
 then goto _2;
IERR := 66;
Result := SYS059;
goto _4;
_2:
if ( P <= PMAX ) 
 then goto _3;
IERR := 66;
Result := SYS059;
goto _4;
_3:
IERR := 0;
EPS := SYS089;
SF23Z(P,0.e0,R1,R2,EPS,1,IERR1);
Result := SF39E(X,P,IERR1)*R1;
_4:
if ( IERR <> 0 ) 
 then UTSF13(IERR,40);
exit;
end;

end.
